Overview | Package | Class | Deprecated | Index | Help
| Groovy Documentation
| FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.gradle
[Java] Class GradleLauncher

    java.lang.Object
      org.gradle.GradleLauncher

    public abstract class GradleLauncher

`GradleLauncher` is the main entry point for embedding Gradle. You use this class to manage a Gradle build, as follows:

1. Optionally create a StartParameter instance and configure it with the desired properties. The properties of `StartParameter` generally correspond to the command-line options of Gradle. You can use createStartParameter(String...) to create a StartParameter from a set of command-line options.
2. Obtain a `GradleLauncher` instance by calling newInstance, passing in the `StartParameter`, or an array of Strings that will be treated as command line arguments.
3. Optionally add one or more listeners to the `GradleLauncher`.
4. Call run to execute the build. This will return a BuildResult. Note that if the build fails, the resulting exception will be contained in the `BuildResult`.
5. Query the build result. You might want to call BuildResult#rethrowFailure()#rethrowFailure() to rethrow any build failure.

Authors:
  Hans Dockter

Method Summary
`void` | `addListener(java.lang.Object listener)` Adds a listener to this build instance.
`void` | `addStandardErrorListener(StandardOutputListener listener)` Adds a StandardOutputListener to this build instance.
`void` | `addStandardOutputListener(StandardOutputListener listener)` Adds a StandardOutputListener to this build instance.
`static StartParameter` | `createStartParameter(java.lang.String commandLineArgs)` Returns a `StartParameter` object out of command line syntax arguments.
`BuildResult` | `getBuildAnalysis()` Evaluates the settings and all the projects.
`BuildResult` | `getBuildAndRunAnalysis()` Evaluates the settings and all the projects.
`static void` | `injectCustomFactory(GradleLauncherFactory gradleLauncherFactory)`
`static GradleLauncher` | `newInstance(StartParameter startParameter)` Returns a `GradleLauncher` instance based on the passed start parameter.
`static GradleLauncher` | `newInstance(java.lang.String commandLineArgs)` Returns a `GradleLauncher` instance based on the passed command line syntax arguments.
`BuildResult` | `run()` Executes the build for this `GradleLauncher` instance and returns the result.
`void` | `useLogger(java.lang.Object logger)` Use the given listener.

Methods inherited from class java.lang.Object
java.lang.Object#wait(long), java.lang.Object#wait(long, int), java.lang.Object#wait(), java.lang.Object#equals(java.lang.Object), java.lang.Object#toString(), java.lang.Object#hashCode(), java.lang.Object#getClass(), java.lang.Object#notify(), java.lang.Object#notifyAll()

Method Detail

### addListener

    public void addListener(java.lang.Object listener)

  Adds a listener to this build instance. The listener is notified of events which occur during the execution of the build. See Gradle.addListener for supported listener types.

  Parameters:
    `listener` - The listener to add. Has no effect if the listener has already been added.

### addStandardErrorListener

    public void addStandardErrorListener(StandardOutputListener listener)

  Adds a StandardOutputListener to this build instance. The listener is notified of any text written to standard error by Gradle's logging system

  Parameters:
    `listener` - The listener to add. Has no effect if the listener has already been added.

### addStandardOutputListener

    public void addStandardOutputListener(StandardOutputListener listener)

  Adds a StandardOutputListener to this build instance. The listener is notified of any text written to standard output by Gradle's logging system

  Parameters:
    `listener` - The listener to add. Has no effect if the listener has already been added.

### createStartParameter

    public static StartParameter createStartParameter(java.lang.String commandLineArgs)

  Returns a `StartParameter` object out of command line syntax arguments. Each command line option has an associated field in the `StartParameter` object.
  Parameters:
    `commandLineArgs` - A String array where each element denotes an entry of the Gradle command line syntax
  Returns:
    The `GradleLauncher`. Never returns null.

### getBuildAnalysis

    public BuildResult getBuildAnalysis()

  Evaluates the settings and all the projects. The information about available tasks and projects is accessible via the Gradle.getRootProject object.
  Returns:
    The result. Never returns null.

### getBuildAndRunAnalysis

    public BuildResult getBuildAndRunAnalysis()

  Evaluates the settings and all the projects. The information about available tasks and projects is accessible via the Gradle.getRootProject object. Fills the execution plan without running the build. The tasks to be executed tasks are available via Gradle.getTaskGraph.
  Returns:
    The result. Never returns null.

### injectCustomFactory

    public static void injectCustomFactory(GradleLauncherFactory gradleLauncherFactory)

### newInstance

    public static GradleLauncher newInstance(StartParameter startParameter)

  Returns a `GradleLauncher` instance based on the passed start parameter.
  Parameters:
    `startParameter` - The start parameter object the GradleLauncher instance is initialized with
  Returns:
    The `GradleLauncher`. Never returns null.

### newInstance

    public static GradleLauncher newInstance(java.lang.String commandLineArgs)

  Returns a `GradleLauncher` instance based on the passed command line syntax arguments.
  Parameters:
    `commandLineArgs` - A String array where each element denotes an entry of the Gradle command line syntax
  Returns:
    The `GradleLauncher`. Never returns null.

### run

    public BuildResult run()

  Executes the build for this `GradleLauncher` instance and returns the result. Note that when the build fails, the exception is available using BuildResult.getFailure.

  Returns:
    The result. Never returns null.

### useLogger

    public void useLogger(java.lang.Object logger)

  Use the given listener. See Gradle.useLogger for details.
  Parameters:
    `logger` - The logger to use.

Groovy Documentation